/*
 * process, Distribution repositories and basic setup for Emmanuel Bigeon projects
 * Copyright (C) 2014-2017 E. Bigeon
 * mailto:emmanuel@bigeon.fr
 *
 * This software is governed by the CeCILL license under French law and
 * abiding by the rules of distribution of free software.  You can  use,
 * modify and/or redistribute the software under the terms of the CeCILL
 * license as circulated by CEA, CNRS and INRIA at the following URL
 * "http://www.cecill.info".
 *
 * As a counterpart to the access to the source code and  rights to copy,
 * modify and redistribute granted by the license, users are provided only
 * with a limited warranty  and the software's author,  the holder of the
 * economic rights,  and the successive licensors  have only  limited
 * liability.
 *
 * In this respect, the user's attention is drawn to the risks associated
 * with loading,  using,  modifying and/or developing or reproducing the
 * software by the user in light of its specific status of free software,
 * that may mean  that it is complicated to manipulate,  and  that  also
 * therefore means  that it is reserved for developers  and  experienced
 * professionals having in-depth computer knowledge. Users are therefore
 * encouraged to load and test the software's suitability as regards their
 * requirements in conditions enabling the security of their systems and/or
 * data to be ensured and,  more generally, to use and operate it in the
 * same conditions as regards security.
 *
 * The fact that you are presently reading this means that you have had
 * knowledge of the CeCILL license and that you accept its terms.
 */
/**
 * gclc-process:fr.bigeon.gclc.process.ForkTask.java
 * Created on: Nov 13, 2017
 */
package fr.bigeon.gclc.process;

import java.util.Arrays;
import java.util.HashSet;
import java.util.Set;

import fr.bigeon.gclc.command.ICommand;
import fr.bigeon.gclc.manager.ConsoleInput;
import fr.bigeon.gclc.manager.ConsoleOutput;

/**
 * <p>
 * TODO
 *
 * @author Emmanuel Bigeon
 *
 */
public class ForkTask implements Task {

    private final ICommand command;
    private final String[] args;
    private final Set<InterruptionListener> listeners = new HashSet<>();
    private boolean running = false;

    /** @param cmd the command
     * @param args the arguements */
    public ForkTask(final ICommand cmd, final String[] args) {
        command = cmd;
        this.args = Arrays.copyOf(args, args.length);
    }

    /* (non-Javadoc)
     * @see fr.bigeon.gclc.process.Task#addInterruptionListener(fr.bigeon.gclc.
     * process.InterruptionListener) */
    @Override
    public void addInterruptionListener(final InterruptionListener listener) {
        listeners.add(listener);
    }

    /* (non-Javadoc)
     * @see fr.bigeon.gclc.process.Task#getName() */
    @Override
    public String getName() {
        return command.getCommandName();
    }

    /* (non-Javadoc)
     * @see fr.bigeon.gclc.process.Task#isRunning() */
    @Override
    public boolean isRunning() {
        return running;
    }

    /** @param out the console output
     * @param in the console input */
    public void join(final ConsoleOutput out, final ConsoleInput in) {
        // TODO Auto-generated method stub
        //
        throw new RuntimeException("Not implemented yet");
    }

    /* (non-Javadoc)
     * @see
     * fr.bigeon.gclc.process.Task#rmInterruptionListener(fr.bigeon.gclc.process
     * .InterruptionListener) */
    @Override
    public void rmInterruptionListener(final InterruptionListener listener) {
        listeners.remove(listener);
    }

    /* (non-Javadoc)
     * @see java.lang.Runnable#run() */
    @Override
    public void run() {
        running = true;
        try {
            // TODO Auto-generated method stub
            //
            throw new RuntimeException("Not implemented yet");
        } finally {
            running = false;
        }
    }

    /* (non-Javadoc)
     * @see fr.bigeon.gclc.process.Task#setRunning(boolean) */
    @Override
    public void setRunning(final boolean running) {
        this.running = running;
    }

}
